/*
 *  jquery-eclipsefdn-api - v0.0.44
 *  Fetch and display data from various Eclipse Foundation APIs.
 *  https://github.com/EclipseFdn/jquery-eclipsefdn-api
 *
 *  Made by Christopher Guindon
 *  Under MIT License
 *
 *  Thanks to https://github.com/jquery-boilerplate/jquery-boilerplate, MIT License © Zeno Rocha
 */
!function(e,t,n,a){"use strict";var r="eclipseFdnApi",s={apiUrl:"https://api.eclipse.org",gerritUrl:"https://git.eclipse.org/r",eventUrl:"https://newsroom.eclipse.org/api/events",adsUrl:"https://newsroom.eclipse.org/api/ads",forumsUrl:"https://www.eclipse.org/forums",marketplaceUrl:"https://marketplace.eclipse.org",username:"cguindon",currentUser:"",contentPlaceholder:null,errorMsg:'<i class="fa red fa-exclamation-triangle" aria-hidden="true"></i> An unexpected error has occurred.',gerritUserNotFoundMsg:'<h2 class="h3">Outgoing Reviews</h2>There are no outgoing reviews for this user.<h2 class="h3">Incoming Reviews</h2>There are no incoming reviews for this account.',type:"",itemsPerPage:10,accountsUrl:"https://accounts.eclipse.org",newsroomUrl:"https://newsroom.eclipse.org/api",featuredContent:{},featuredContentType:""};function i(t,n){this.element=t,this.settings=e.extend({},s,n),this._defaults=s,this._name=r,this.init()}e.extend(i.prototype,{init:function(){"string"===e.type(this.settings.type)&&-1!==e.inArray(this.settings.type,["mpFavorites","gerritReviews","recentEvents","forumsMsg","gerritReviewCount","projectsList","mailingListSubscription","newsItems","filteredEvents","featuredStory","featuredFooter","customFeaturedContent","allPromos","singlePromo"])&&this[this.settings.type]()},projectsList:function(){var t=this,n=this.settings.username,r=this.settings.apiUrl;if(!n&&!api_url)return!1;var s=r+"/account/profile/"+n+"/projects";e.ajax(s,{context:this.element,success:function(n){var r=Object.keys(n).length;if(r===a&&(r=0),e(this).children("strong").text(r+t.plurialString(" project",r)),!(t.settings.contentPlaceholder instanceof jQuery))return!1;var s=e(t.settings.contentPlaceholder),i=e("<a></a>");s.append(e("<h2></h2>").addClass("h3").text("Eclipse Projects")),s.append('<p>Projects are the organizational unit for open source development work at the Eclipse Foundation. Projects have developers (committers), source code repositories, build servers, downloads, and other resources. The Eclipse Foundation\'s open source projects are governed by the <a href="https://eclipse.org/projects/dev_process/">Eclipse Development Process</a>.</p>');var o="This user is";if(t.settings.currentUser===t.settings.username&&(o="You are"),0===r)return s.append('<div class="alert alert-warning" role="alert">'+o+" not involved in any Eclipse Projects.</div>"),!1;var l=e("<table></table>").attr({width:"100%",class:"table"}),c=e("<tr></tr>"),p=e("<th></th>"),d=e("<td></td>");c.append(p.clone().text("Project").attr("width","85%")),c.append(p.clone().text("Relation").attr({width:"15%",class:"text-center"})),l.append(c),e.each(n,(function(n,a){var r=[],s="",o="";e.each(a,(function(e,t){r.push(t.Relation.Description),s=t.ProjectName,o=t.ActiveDate,""!==t.url&&(s=i.clone().attr({href:t.url}).text(s))})),(c=e("<tr></tr>")).append(d.clone().html(s).append("<br/><small>Since: "+t.dateFormat(new Date(o))+"</small>")),c.append(d.clone().text(r.join(", ")).attr("class","text-center")),l.append(c)}));var u=e("<div></div>").attr({class:"table-responsive"});u.append(l),s.append(u)},error:function(){e(this).html(t.settings.errorMsg)}})},forumsMsg:function(){var t=this,n=this.settings.username,r=this.settings.apiUrl;if(!n&&!api_url)return!1;var s=r+"/account/profile/"+n+"/forum?page=1&pagesize="+t.settings.itemsPerPage;function i(n){var a=e("#forum-posts");e.each(n.posts,(function(r,s){var i={forum_id:s.thread_forum_id,forum_name:s.forum_name,forum_cat_id:s.forum_name,forum_cat_name:s.cat_name,root_subject:s.root_msg_subject,current_user_last_post_timestamp:s.msg_group_post_stamp,current_user_last_post_subject:s.last_user_msg_subject,thread_id:s.msg_thread_id,thread_reply_count:s.thread_replies,thread_views_count:s.thread_views,thread_last_post_date:s.thread_last_post_date,last_message_timestamp:s.last_msg_post_stamp,last_message_poster_id:s.last_msg_poster_id,last_message_poster_alias:s.last_poster_alias,last_message_last_view:s.read_last_view,current_user_id:n.id},o=e("<tr></tr>"),l=e("<td></td>"),c=e("<a></a>"),p=c.clone().attr({href:t.settings.forumsUrl+"/index.php/f/"+i.forum_id+"/"}).text(i.forum_name),d=c.clone().attr({href:t.settings.forumsUrl+"/index.php/i/"+i.forum_cat_id+"/"}).text(i.forum_cat_name),u=e("<small></small>").append("<br/>").append(d).append(" &gt; ").append(p).append(" &gt; ").append(i.root_subject).append("<br>Posted on "+t.dateFormat(new Date(parseInt(1e3*i.current_user_last_post_timestamp)))),g="fa fa-envelope-open-o";t.settings.currentUser===t.settings.username&&i.last_message_last_view<i.thread_last_post_date&&i.last_message_poster_id!==i.current_user_id&&(o.addClass("warning"),g="fa fa-envelope-o"),t.settings.currentUser===t.settings.username&&o.append(l.clone().html('<i class="'+g+'" aria-hidden="true"></i>').attr("class","text-center")),o.append(l.clone().html(c.clone().attr({href:t.settings.forumsUrl+"/index.php/t/"+i.thread_id+"/"}).text(i.current_user_last_post_subject)).append(u)),o.append(l.clone().text(i.thread_reply_count).attr("class","text-center")),o.append(l.clone().text(i.thread_views_count).attr("class","text-center"));var h=e("<small></small>").append(t.dateFormat(new Date(parseInt(1e3*i.last_message_timestamp)))).append("<br/> By: ").append(c.clone().attr({href:t.settings.forumsUrl+"/index.php/sp/"+i.last_message_poster_id+"/"}).text(i.last_message_poster_alias));o.append(l.clone().html(h).attr("class","text-center")),a.append(o)}))}function o(a,s,o){!function(a,s){void 0===a&&(a=1);void 0===s&&(s=t.settings.itemsPerPage);var o=r+"/account/profile/"+n+"/forum?page="+a+"&pagesize="+s;e.ajax(o,{context:t.element,success:function(e){i(e)},error:function(){e(this).html(t.settings.errorMsg)}})}(s,o)}e.ajax(s,{context:this.element,success:function(n,r,s){var l=0;if(n.posted_msg_count!==a&&n.id!==a&&(l=n.posted_msg_count,e(this).attr({href:t.settings.forumsUrl+"/index.php/sp/"+n.id+"/"})),e(this).children("strong").text(l+t.plurialString(" topic",l)),!(t.settings.contentPlaceholder instanceof jQuery))return!1;var c=e(t.settings.contentPlaceholder),p=e("<a></a>");c.append(e("<h2></h2>").addClass("h3").text("Eclipse Forums")),c.append(e("<p></p>").append("The Eclipse forums are your way of communicating with the community of people developing and using Eclipse-based tools hosted at Eclipse.org. Please stick to technical issues - and remember, no confidential information - these are public forums!"));var d=p.clone().attr({href:t.settings.forumsUrl,class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');if(0===n.posts.length)return c.append('<div class="alert alert-warning" role="alert">This user does not have any activities on Eclipse Forums.</div>'),c.append(d),!1;var u=e("<table></table>").attr({width:"100%",class:"table",id:"forum-posts"}),g=e("<tr></tr>"),h=e("<th></th>");t.settings.currentUser===t.settings.username&&g.append(h.clone().attr("width","8%")),g.append(h.clone().text("Topics").attr("width","50%")),g.append(h.clone().text("Replies").attr({width:"8%",class:"text-center"})),g.append(h.clone().text("Views").attr({width:"8%",class:"text-center"})),g.append(h.clone().text("Last message").attr({class:"text-center"})),u.append(g);var f=e("<div></div>").attr({class:"table-responsive"});f.append(u),c.append(f),i(n);var m=new t.linkHeaderParser(s.getResponseHeader("Link")),v=m.getLastPageNum();m.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=m.getPageSize()),u.on("fetchPageItemsEvent",o),u.data("postsPerPage",t.settings.itemsPerPage),c.append(t.getPaginationBar(v*t.settings.itemsPerPage,"forum-posts"));var b=n.id;d.attr({href:t.settings.forumsUrl+"/index.php/sp/"+b+"/"}),c.append(d)},error:function(){e(this).html(t.settings.errorMsg)}})},mpFavorites:function(){var t=this,n=this.settings.username,a=this.settings.apiUrl;if(!n&&!api_url)return!1;if(t.settings.contentPlaceholder instanceof jQuery){var r=e(t.settings.contentPlaceholder),s=e("<a></a>").attr({href:t.settings.marketplaceUrl+"/user/"+n+"/favorites",class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');r.append(e("<h2></h2>").addClass("h3").text("Eclipse Marketplace Favorites")),r.append(e("<p></p>").append("Eclipse Marketplace is the source for Eclipse-based solutions, products and add-on features. Thousands of developers visit Marketplace on a monthly basis to find new and innovative solutions. Solution providers are encouraged to list their products on Marketplace to gain exposure to the Eclipse developer community."))}var i=a+"/marketplace/favorites?name="+n+"&page=1&pagesize="+t.settings.itemsPerPage;function o(n){var a=t.settings.marketplaceUrl+"/node/"+n+"/api/p";e.ajax(a,{context:t.element,success:function(n){var a=e("#mpfavorites-list");e("node",n).each((function(n,r){var s=e(r),i=s.find("shortdescription").text(),o=r.getAttribute("name"),l=s.find("changed").text(),c=s.find("owner").text(),p="Last Updated on "+t.dateFormat(new Date(parseInt(1e3*l)))+" by "+c,d=r.getAttribute("id"),u=e("#mp-listing-template").clone().removeClass("hidden").removeAttr("id"),g=e("<a></a>"),h=e("category",r),f=t.settings.marketplaceUrl+"/node/"+d,m=s.find("image").text(),v=g.clone().attr({href:f});h.each((function(e,t){var n=g.clone().attr({href:t.getAttribute("url")}).text(t.getAttribute("name"));h.length!==e+1&&n.append(", "),u.find(".content-categories").append(n)})),u.find(".listing-image").attr({href:f,style:"background:url('"+m+"') no-repeat center;"}),u.find(".drag").attr({href:t.settings.marketplaceUrl+"/marketplace-client-intro?mpc_install="+d}),u.find(".listing-title").html(v.clone().text(o)),u.find(".content-teaser").html(i),u.find(".content-last-updated").html(p),a.append(u)}))},error:function(){e(this).html(t.settings.errorMsg)}})}function l(r,s,i){!function(r,s){void 0===r&&(r=1);void 0===s&&(s=t.settings.itemsPerPage);var i=a+"/marketplace/favorites?name="+n+"&page="+r+"&pagesize="+s;e.ajax(i,{context:t.element,success:function(t){var n=[];e.each(t.mpc_favorites,(function(e,t){n.push(t.content_id)})),o(n.join())},error:function(){e(this).html(t.settings.errorMsg)}})}(s,i)}e.ajax(i,{context:this.element,success:function(n,a,i){if(e(this).children("strong").text(n.result.count+t.plurialString(" favorite",n.result.count)),void 0===r)return!1;var c=[];if(e.each(n.mpc_favorites,(function(e,t){c.push(t.content_id)})),0===c.length)return r.append('<div class="alert alert-warning" role="alert">There are no marketplace favorites for this user.</div>'),r.append(s),!1;var p=new t.linkHeaderParser(i.getResponseHeader("Link")),d=p.getLastPageNum();p.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=p.getPageSize()),r.on("fetchPageItemsEvent",l),r.append('<h3 id="mpc_list_name">'+n.mpc_list_name+"</h3>"),r.append('<div class="row"><div class="col-md-17"><div class="form-item form-type-textfield form-disabled"><label>Favorites URL <a href="#" class="install-user-favorites" data-container="body" data-toggle="popover" data-placement="top" title="" data-original-title="How to install?"><i class="fa fa-question-circle" aria-hidden="true"></i></a> </label><input disabled="true" class="form-control form-text" type="text" value="http://marketplace.eclipse.org/user/'+t.settings.username+'/favorites" size="60" maxlength="128"></div></div><div class="col-md-7 margin-top-25 text-right"><div class="drag_installbutton drag_installbutton_v2 drag-install-favorites"><a href="http://marketplace.eclipse.org/user/'+t.settings.username+'/favorites" class="drag" title="How to install?"><span class="btn btn-default"><i class="fa fa-download orange"></i> Install Favorites</span><div class="tooltip tooltip-below-right"><h3>Drag to Install!</h3>Drag to your running Eclipse<sup>*</sup> workspace to install this favorite list. <br><sup>*</sup>Requires Eclipse Marketplace Client.</div></a></div></div></div>'),r.append('<div id="mpfavorites-list"></div>'),r.find("#mpfavorites-list").data("postsPerPage",t.settings.itemsPerPage),o(c.join()),r.append(t.getPaginationBar(d*t.settings.itemsPerPage,"mpfavorites-list")),r.append(s),e("a.install-user-favorites").on("click",(function(e){e.preventDefault()})),e("a.install-user-favorites").popover({html:!0,content:function(){return e("<ol></ol>").addClass("padding-left-20").append("<li>Copy <strong>URL</strong> from textfield.</li>").append("<li>Open Eclipse Marketplace Client (MPC).</li>").append("<li>Open <strong>Favorites</strong> tab.</li>").append("<li>Click on <strong>Import Favorites list</strong>.</li>").append("<li>Paste <strong>URL</strong> in the textfield.</li>")}})},error:function(){e(this).html(t.settings.errorMsg)}})},gerritReviewCount:function(){var t=this,n=this.settings.username,a=this.settings.apiUrl+"/account/profile/"+n+"/gerrit";e.ajax(a,{context:this.element,success:function(n){var a=n.merged_changes_count;e(this).children("strong").text(a+t.plurialString(" review",a)),a>0&&e(this).attr({href:t.settings.gerritUrl+"/#/q/owner:"+t.settings.username})},error:function(){e(this).html(t.settings.errorMsg)}})},mailingListSubscription:function(){var t=this,n=t.settings.username,a=t.settings.currentUser,r=t.settings.currentUserUid,s=t.settings.userCanEditOwnMailingList,i=this.settings.apiUrl;if(!n&&!api_url)return!1;var o=t.element,l=i+"/account/profile/"+n+"/mailing-list";e.ajax(l,{context:this.element,success:function(t){var i=t.mailing_list_subscriptions,l=e("<p></p>"),c=e("<h2></h2>"),p=e("<a></a>"),d=e("<strong></strong>"),u="This user is";a===n&&(u="You are");var g=p.clone().attr({href:"/user/"+r+"/mailing-list",class:"fa fa-pencil","aria-hidden":"true"});if(e(o).append(c.text("Eclipse Mailing Lists ").append(g)),jQuery.isEmptyObject(i))e(o).append(l.clone().text(u+" not subscribed to any Eclipse mailing list."));else{e(o).append(l.clone().text("The Eclipse Mailing lists are another way for you to interact with your favorite Eclipse project.")),e(o).append(l.clone().text("Below is a list of the public mailing lists that "+u.toLowerCase()+" currently  subscribed to at Eclipse.org. When posting emails to our mailing lists, please remember that these lists are public, avoid posting ").append(d.clone().text("personal")).append(" or ").append(d.clone().text("private information")).append(".")),e(o).append(l.clone().text("If you are having trouble using our mailing lists, please contact ").append(p.clone().attr("href","mailto:mailman@eclipse.org").text("mailman@eclipse.org")).append("."));var h=e("<table></table>").attr({width:"100%",class:"table",id:"aeri-reports"}),f=e("<tr></tr>"),m=e("<th></th>");f.append(m.clone().text("Mailing List").attr("width","30%")),f.append(m.clone().text("Description").attr("width","70%")),h.append(f);var v=e("<div></div>").attr({class:"table-responsive"});v.append(h),e(o).append(v),e(o).append(l),e.each(i,(function(t,n){var a=e("<tr></tr>"),r=e("<td></td>");a.append(r.clone().append(p.clone().attr("href","/mailing-list/"+n.list_name).text(n.list_name))),a.append(r.clone().append(n.list_description)),h.append(a)}))}a===n&&s&&e(o).append(l.clone().append(p.clone().attr({href:"/user/"+r+"/mailing-list",class:"btn btn-primary btn-xs"}).text("Manage your Mailing Lists")))},error:function(){e(this).html(t.settings.errorMsg)}})},gerritReviews:function(){var t,n,a=this,r=this.settings.gerritUrl+"/changes/?q=owner:"+this.settings.username+"+status:open&q=reviewer:"+this.settings.username+"+status:open+-owner:"+this.settings.username+"&pp=0";e(this.element).append(e("<h2>Eclipse Gerrit</h2>").addClass("h3")),e(this.element).append("<p>Gerrit is a web based code review system, facilitating online code reviews for projects using the Git version control system.</p>"),t=r,n=[["gerrit-outgoing",[]],["gerrit-incoming",[]]],e(a.element).on("drawTableEvent",(function(){e.each(n,(function(t,n){var r="";switch(n[0]){case"gerrit-outgoing":r="Outgoing Reviews";break;case"gerrit-incoming":r="Incoming Reviews"}var s=e("<h4></h4>").addClass("h4").text(r);e(a.element).append(s),0!==n[1].length?(e(a.element).append(function(t,n){var r=e("<table></table>").attr({width:"100%",class:"table",id:t}),s=e("<tr></tr>"),i=e("<th></th>"),o=e("<td></td>");s.append(i.clone().text("Subject").attr("width","70%")),s.append(i.clone().text("Status").attr({width:"18%",class:"text-center"})),s.append(i.clone().text("Updated").attr({width:"12%",class:"text-center"})),r.append(s);var l=e("<a></a>");e.each(n,(function(t,n){s=e("<tr></tr>");var i="";!1===n.mergeable&&(i="Merge Conflict",s.addClass("warning"));var c=n.updated.substring(0,n.updated.indexOf(" "));s.append(o.clone().html(l.clone().attr({href:a.settings.gerritUrl+"/"+n._number}).text(n.subject)).append("<br/>"+n.project)),s.append(o.clone().text(i).attr("class","text-center")),s.append(o.clone().text(c).attr("class","text-center")),r.append(s)}));var c=e("<div></div>").attr({class:"table-responsive"});return c.append(r),c}(n[0],n[1])),e(a.element).append(a.getPaginationBar(n[1].length,n[0]))):e(a.element).append('<div class="alert alert-warning" role="alert">There are no '+r.toLowerCase()+" for this user.</div>")}));var t=e("<a></a>").attr({href:a.settings.gerritUrl+"/#/q/owner:"+a.settings.username,class:"btn btn-primary btn-sm",style:"display:block"}).html('<i class="fa fa-angle-double-right" aria-hidden="true"></i> More');e(a.element).append(t)})),function t(r,s,i){return r+="&start="+(i=void 0!==i?i:0)+"&n="+(s=void 0!==s?s:100),e.ajax(r,{dataType:"gerrit_XSSI",context:a.element,converters:{"text gerrit_XSSI":function(e){var t=e.substring(e.indexOf("\n")+1);return jQuery.parseJSON(t)}},success:function(o){var l=Object,c=Object;0!==o[0].length&&(e.merge(n[0][1],o[0]),l=o[0][o[0].length-1]),0!==o[1].length&&(e.merge(n[1][1],o[1]),c=o[1][o[1].length-1]),"_more_changes"in l&&!0===l._more_changes||"_more_changes"in c&&!0===c._more_changes?t(r,s,i+s):e(a.element).trigger("drawTableEvent")},error:function(t){400===t.status?e(this).html(a.settings.gerritUserNotFoundMsg):e(this).html(a.settings.errorMsg)}})}(t,100,0)},recentEvents:function(){var t=this;function n(e,t){return e.dateTime-t.dateTime}e.ajax(this.settings.eventUrl,{context:this.element,success:function(a){var r=new Date,s=[];for(var i in a.events)a.events[i].dateTime=new Date(a.events[i].date),a.events[i].dateTime>=r&&s.push(a.events[i]);s.sort(n);var o=e("<ul></ul>").attr({class:"nav",style:"margin:0"});for(var l in s.slice(0,5)){var c=s[l].dateTime,p=t.dateFormat(c),d=e("<a>").attr({href:s[l].infoLink}).html(s[l].title+"<br/><small>"+p+"</small>"),u=e("<li></li>").append(d);o.append(u)}e(this).children(".loading").remove(),e(this).append(o);var g=e("<a>").attr({href:"http://events.eclipse.org",class:"btn btn-simple btn-sm"}).text("more");e(this).append(g)},error:function(){e(this).html(t.settings.errorMsg)}})},plurialString:function(e,t){return t>1&&(e+="s"),e},dateFormat:function(e){var t=e.getFullYear(),n=["January","February","March","April","May","June","July","August","September","October","November","December"][e.getMonth()];return["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"][e.getDay()]+", "+n+" "+e.getDate()+", "+t+" - "+("0"+e.getHours()).slice(-2)+":"+("0"+e.getMinutes()).slice(-2)},linkHeaderParser:function(e){var t=this;if(this.links=0,this.getLastPageNum=function(){return void 0===t.links.last?0:o(t.links.last,"page")},this.getPageSize=function(){if(void 0===t.links.first)return 0;var e=o(t.links.first,"pagesize");return 0===e?o(t.links.first,"size"):e},null!=e){for(var n=e.split(","),a={},r=0;r<n.length;r++){n[r]=n[r].replace("&amp;","&");var s=n[r].split(";");if(!(s.length<2)){var i=s[0].replace(/<(.*)>/,"$1").trim();a[s[1].replace(/rel="(.*)"/,"$1").trim()]=i}}this.links=a}function o(e,t){if(void 0===t||void 0===e)return 0;for(var n=e.substr(e.lastIndexOf("?")+1).split("&"),a=0;a<n.length;a++){var r=n[a].split("=");if(decodeURIComponent(r[0])===t)return decodeURIComponent(r[1])}return 0}},getPaginationBar:function(t,n){var a=this;if(void 0===t&&(t=1),!(t<=0||t<=a.settings.itemsPerPage)){var r=e("<nav></nav>").attr({"arial-label":"Page navigation",id:n+"-pager"}).addClass("text-center"),s=Math.ceil(t/a.settings.itemsPerPage),i=o(s,1,n);return r.append(i),void 0===e("#"+n).data("pageCache")&&function(){var t,r=e("#"+n),i=[];switch(n){case"gerrit-incoming":case"gerrit-outgoing":t="gerrit",i=o(r.find("tr"));break;case"mpfavorites-list":t="mpfav";break;case"forum-posts":case"aeri-reports":t="table",i=o(r.find("tr"));break;case"news-container":t="news";break;case"events-container":t="events";break;default:t="generic"}switch(r.data("pageCache",i),r.data("pageCacheType",t),r.data("pageCacheTotalPages",s),r.on("changePageEvent",c),t){case"gerrit":r.trigger("changePageEvent",[1])}function o(n){var r=0,s=0,i=[],o=[];switch(t){case"gerrit":case"table":o[0]=n[0]}return e.each(n,(function(t,n){if(e(n).children().first().is("th"))return!0;r===a.settings.itemsPerPage&&(r=0,o[++s]=i,i=[]),i[r++]=n})),i.length>0&&(o[++s]=i),o}}(),r}function o(t,n,a){var r=e("<li></li>"),s=e("<ul></ul>").addClass("pagination");void 0!==a&&s.attr({"data-eclipseFdnApi-elementID":a});var i,o=!1,c="",p=1,d=t,u=function(){var t=e(this),n=t.attr("data-goto-page"),a=t.parents(".pagination").eq(0).data("eclipsefdnapiElementid");e("#"+a).trigger("changePageEvent",[n])};if(t>9){p=t-8,n<=5?(d=9,p=1):n<=t-4&&(p=n-4,d=n+4),o=!0;var g=e("<span></span>");c=r.clone().append(g.clone().html("...").attr({"aria-hidden":"true"})).addClass("pager-ellipses disabled")}for(1!==n&&(s.append(r.clone().addClass("pager-first").html(l("First","first page",1,"<< first").on("click",u))),s.append(r.clone().html(l("Previous","previous page",n-1,"< previous").on("click",u))),!0===o&&p>1&&s.append(c.clone())),i=p;i<=d;i++){var h=r.clone(),f=l("Page "+parseInt(i),"page "+parseInt(i),i).on("click",u);n===i&&h.addClass("active"),h.html(f),s.append(h)}return n<t&&(!0===o&&d<t&&s.append(c.clone()),s.append(r.clone().html(l("Next","next page",n+1,"next >").on("click",u))),s.append(r.clone().addClass("pager-last").html(l("Last","last page",t,"last >>").on("click",u)))),s}function l(t,n,a,r){return void 0===r&&(r=parseInt(a)),e("<a></a>").attr({"aria-label":t,href:"#",onclick:"return false;",title:"Go to "+n,"data-goto-page":parseInt(a)}).text(r)}function c(t,n){var a=e(t.currentTarget),r=a.data("pageCacheType"),s=a.data("pageCache"),i=a.attr("id"),l=e("#"+i+"-pager"),c=l.data("currentPage");switch(null==c&&(c=1),void 0===n&&(n=1),n=parseInt(n),r){case"gerrit":d();break;default:!function(){if(void 0===s[c]){var t=[];s[c]=[],a.is("table")?t=a.find("tr"):a.is("div")&&(t=a.find(".node,.item")),e.each(t,(function(t,n){if(e(n).children().first().is("th"))return!0;s[c].push(n)})),a.data("pageCache",s)}}(),d()}if(c!==n){var p=o(a.data("pageCacheTotalPages"),n,i);l.find("ul").replaceWith(p),l.data("currentPage",n)}function d(){if(a.empty(),void 0===s[n]){var t=[];switch(r){case"mpfav":case"table":case"news":case"events":t.push(n),t.push(a.data("postsPerPage"))}return a.is("table")&&a.append(s[0]),void a.trigger("fetchPageItemsEvent",t)}a.is("table")&&a.append(s[0]),e.each(s[n],(function(e,t){a.append(t)}))}}},newsItems:function(){var t=this,n=e(e(this)[0].element),r=n.find("> div.news-container");function s(r,s,i){var o=e(r),l=o.parent(),c=l.data("news-count")||i||5,p="?page="+s;p+="&pagesize="+c,p+=d(l,"publish-target","publish_to","eclipse_org"),p+=d(l,"news-type","news_type","");var u=t.settings.newsroomUrl+"/news"+p;e.ajax(u,{success:function(n,r,s){var i=n.news;i.length>c&&(i=i.slice(0,c));for(var p=0;p<i.length;p++)i[p].date=t.dateFormat(new Date(i[p].date)),i[p].index=p;var d=function(t){var n=e("#"+t);if(n!==a&&0!==n.length)return n[0].innerHTML;return'{{#news}}<div class="item block-summary-item" data-mh="group-{{ index }}"><p>{{ date }}</p><h4><a href="{{ link }}">{{ title }}</a></h4><p>{{ body }}</p></div>{{/news}}'}(l.data("template-id")||"template-news-items"),u=Mustache.render(d,{news:i});if(o.html(u),!0===l.data("pagination")&&0===l.find("nav").length){var g=new t.linkHeaderParser(s.getResponseHeader("Link")),h=g.getLastPageNum();g.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=g.getPageSize()),l.append(t.getPaginationBar(h*t.settings.itemsPerPage,o.attr("id")))}l.trigger("shown.ef.news")},error:function(){n.empty();var t=e("<div></div>");t.attr("class","alert alert-warning"),t.text("Unable to load news content currently."),n.append(t)}})}0===r.length&&((r=e("<div></div>")).attr({class:"news-container",id:"news-container"}),n.append(r)),!0===n.data("pagination")&&r.on("fetchPageItemsEvent",(function(e,t,n){s(e.target,t,n)})),s(r,1,5)},filteredEvents:function(){var t=this,n=e(e(this)[0].element),r=n.find("> div.events-container");function s(r,s,i){var o=e(r),l=o.parent(),c=l.data("count")||i||5,p="?page="+s;p+="&pagesize="+c,p+=d(l,"publish-target","publish_to",a),p+=d(l,"type","type",a),p+=d(l,"upcoming","upcoming_only",a);var u=1===l.data("upcoming"),g=l.data("sort-order")||(u?"ASC":a),h=l.data("sort-field")||(u?"field_event_date":a);g&&h&&(p+="&options%5Borderby%5D%5B"+h+"%5D="+g);var f=t.settings.newsroomUrl+"/events"+p;e.ajax(f,{success:function(n,r,s){var i=n.events;i.length>c&&(i=i.slice(0,c));for(var p=0;p<i.length;p++)(Date.now()>new Date(i[p]["end-date"])||!i[p].registration)&&delete i[p].registration,i[p].infoLink||delete i[p].infoLink,i[p].date=t.dateFormat(new Date(i[p].date)),i[p]["end-date"]=t.dateFormat(new Date(i[p]["end-date"]));var d=function(t,n){var r=e("#"+t);if(r!==a&&0!==r.length)return r[0].innerHTML;if(n)return'{{#events}}<div class="item block-summary-item match-height-item"><h3 class="h4">{{ title }}</h3><p>{{ locationName }}</p><p>{{ date }} - {{ end-date }}</p><p class="margin-bottom-0">{{#registration}}<a class="btn btn-secondary" href="{{ registration }}">Register Now</a>{{/registration}}{{#infoLink}}<a class="btn btn-secondary" href="{{ infoLink }}">More information</a>{{/infoLink}}</p></div>{{/events}}';return'{{#events}}<div class="col-sm-12 col-md-6 event item match-height-item-by-row flex-column"><h3 class="h4 flex-grow">{{ title }}</h3><p>{{ locationName }}</p><p class="flex-grow">{{ date }} - {{ end-date }}</p><p class="margin-bottom-0">{{#infoLink}}<a class="btn btn-secondary" href="{{ infoLink }}">More information</a>{{/infoLink}}{{^infoLink}}{{#registration}}<a class="btn btn-secondary" href="{{ registration }}">Register Now</a>{{/registration}}{{/infoLink}}</p></div>{{/events}}'}(l.data("template-id")||"template-event-items",l.data("archive")||!1),u=Mustache.render(d,{events:i});if(o.html(u),!0===l.data("pagination")&&0===l.find("nav").length){var g=new t.linkHeaderParser(s.getResponseHeader("Link")),h=g.getLastPageNum();g.getPageSize()!==t.settings.itemsPerPage&&(t.settings.itemsPerPage=g.getPageSize()),l.append(t.getPaginationBar(h*t.settings.itemsPerPage,o.attr("id")))}l.trigger("shown.ef.events")},error:function(){n.empty();var t=e("<div></div>");t.attr("class","alert alert-warning"),t.text("Unable to load events content currently."),n.append(t)}})}0===r.length&&((r=e("<div></div>")).attr({class:"events-container",id:"events-container"}),n.append(r)),!0===n.data("pagination")&&r.on("fetchPageItemsEvent",(function(e,t,n){s(e.target,t,n)})),s(r,1,5)},featuredStory:function(){var t=e(e(this)[0].element);c(t,"story",this.settings)},featuredFooter:function(){var t=e(e(this)[0].element);c(t,"footer",this.settings)},customFeaturedContent:function(){var t=e(e(this)[0].element);p(this.settings.featuredContent,t,this.settings.featuredContentType)},allPromos:function(){var t=e(e(this)[0].element),n=this,r=t.find("> div.promos-container");function s(t,r,s){var i=e(t),l=i.parent(),c=l.data("count")||s||10,p=n.settings.adsUrl,u="?page="+r;u+="&pagesize="+c,u+=d(l,"publish-target","publish_to",a),e.ajax(p+u,{dataType:"json",type:"GET",success:function(e){e.ads===a&&console.log("Could not load promotional content. AD-01");for(var t=0;t<e.ads.length;t++)e.ads[t].idx=t;if(o(i,e.ads,n.settings),!0===l.data("pagination")&&0===l.find("nav").length){var r=new n.linkHeaderParser(jqXHR.getResponseHeader("Link")),s=r.getLastPageNum();r.getPageSize()!==n.settings.itemsPerPage&&(n.settings.itemsPerPage=r.getPageSize()),l.append(n.getPaginationBar(s*n.settings.itemsPerPage,i.attr("id")))}},error:function(){console.log("Could not load promotional content. AD-02")}})}0===r.length&&((r=e("<div></div>")).attr({class:"promos-container",id:"promos-container-"+getPseudoRandomNumber()}),t.append(r)),!0===t.data("pagination")&&r.on("fetchPageItemsAd",(function(e,t,n){s(e.target,t,n)})),s(r,1,10)},singlePromo:function(){var n=this,r=e(e(n)[0].element),s=r.parent(),i=n.settings.adsUrl,l={host:t.location.host,source:t.location.pathname,publish_to:r.data("publish-target")};e.ajax(i,{dataType:"json",contentType:"application/json",type:"POST",data:JSON.stringify(l),success:function(e){e===a&&console.log("Could not load promotional content, bad content received. AD-03"),o(r,e,n.settings),s.trigger("shown.ef.ads")},error:function(){console.log("Could not load promotional content. AD-04")}})}}),e.fn[r]=function(t){return this.each((function(){e.data(this,"plugin_"+r)||e.data(this,"plugin_"+r,new i(this,t))}))};var o=function(e,t,n){var a=l(e.data("template-id"),n);e.html(Mustache.render(a,{content:t}))},l=function(e,t){return"allPromos"===t.type?u(e,'{{#content}}<p><a href="http://www.eclipse.org/home/index.php?ad_id={{ id }}">Ad ID: {{ id }}</a><span class="margin-left-10">prob: {{ weight }}%</span><div class="eclipsefnd-ad ad-strategic ad-strategic-default"><a href="{{ url }}" rel="nofollow" style="background-image: url(\'{{ image }}\')">{{ member_name }}</a></div></p>{{/content}}'):u(e,'{{#content}}<div class="eclipsefnd-ad ad-strategic ad-strategic-default"><a href="{{ url }}" rel="nofollow" style="background-image: url(\'{{ image }}\')">{{ member_name }}</a></div>{{/content}}')},c=function(t,n,r){var s=e(t),i=r.newsroomUrl+"/featured_story",o=s.data("id");o!==a&&(i+="/"+o),i+=d(s,"publish-target","publish_to",a,!0),e.ajax(i,{success:function(e){e.featured_story===a&&console.log("Could not load featured content, bad content recieved");var t=e.featured_story.filter((function(e){return new Date(e["end-date"])>new Date&&(e["start-date"]===a||new Date(e["start-date"])<new Date)})).filter((function(e){return e.type===n||"both"===e.type}));if(t.length>1&&g(t),t.length>0)p(t[0],s,n);else{p({id:"default-featured-story",layout:"light",title:"Eclipse Foundation Events",body:"Join the world’s leading technologists and open source leaders at Eclipse Foundation events to share ideas, learn and collaborate.",links:[{url:"https://events.eclipse.org",title:"View Events"}]},s,"both")}},error:function(){console.log("Could not load featured content!")}})},p=function(e,t,n){var a=t.find(".featured-container");t.addClass("featured-story-nid-"+e.id),t.addClass("featured-story-"+e.layout);var r=t.data("template-id")||"template-featured-"+n,s=u(r,'{{#content}}<h2 class="margin-top-30">{{ title }}</h2><p>{{ body }}</p><ul class="list-inline list-inline-xs-margin">{{#links}}<li><a class="btn btn-primary" href="{{ url }}">{{ title }}</a></li>{{/links}}</ul>{{/content}}'),i=Mustache.render(s,{content:e});a.html(i)},d=function(e,t,n,r,s){var i=e.data(t)||r,o="";if(Array.isArray(i))for(var l=0;l<i.length;l++)o+=s&&0===l?"?":"&",o+="parameters%5B"+n+"%5D%5B%5D="+i[l];else i!==a&&(o+=s?"?":"&",o+="parameters%5B"+n+"%5D="+i);return o},u=function(t,n){var r=e("#"+t);return r!==a&&0!==r.length?r[0].innerHTML:n},g=function(e){for(var t=e.length-1;t>0;t--){var n=Math.floor(Math.random()*(t+1)),a=e[t];e[t]=e[n],e[n]=a}}}(jQuery,window,document),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Mustache=t()}(this,(function(){"use strict";var e=Object.prototype.toString,t=Array.isArray||function(t){return"[object Array]"===e.call(t)};function n(e){return"function"==typeof e}function a(e){return e.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g,"\\$&")}function r(e,t){return null!=e&&"object"==typeof e&&t in e}var s=RegExp.prototype.test;var i=/\S/;function o(e){return!function(e,t){return s.call(e,t)}(i,e)}var l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;","`":"&#x60;","=":"&#x3D;"};var c=/\s*/,p=/\s+/,d=/\s*=/,u=/\s*\}/,g=/#|\^|\/|>|\{|&|=|!/;function h(e){this.string=e,this.tail=e,this.pos=0}function f(e,t){this.view=e,this.cache={".":this.view},this.parent=t}function m(){this.templateCache={_cache:{},set:function(e,t){this._cache[e]=t},get:function(e){return this._cache[e]},clear:function(){this._cache={}}}}h.prototype.eos=function(){return""===this.tail},h.prototype.scan=function(e){var t=this.tail.match(e);if(!t||0!==t.index)return"";var n=t[0];return this.tail=this.tail.substring(n.length),this.pos+=n.length,n},h.prototype.scanUntil=function(e){var t,n=this.tail.search(e);switch(n){case-1:t=this.tail,this.tail="";break;case 0:t="";break;default:t=this.tail.substring(0,n),this.tail=this.tail.substring(n)}return this.pos+=t.length,t},f.prototype.push=function(e){return new f(e,this)},f.prototype.lookup=function(e){var t,a,s,i=this.cache;if(i.hasOwnProperty(e))t=i[e];else{for(var o,l,c,p=this,d=!1;p;){if(e.indexOf(".")>0)for(o=p.view,l=e.split("."),c=0;null!=o&&c<l.length;)c===l.length-1&&(d=r(o,l[c])||(a=o,s=l[c],null!=a&&"object"!=typeof a&&a.hasOwnProperty&&a.hasOwnProperty(s))),o=o[l[c++]];else o=p.view[e],d=r(p.view,e);if(d){t=o;break}p=p.parent}i[e]=t}return n(t)&&(t=t.call(this.view)),t},m.prototype.clearCache=function(){void 0!==this.templateCache&&this.templateCache.clear()},m.prototype.parse=function(e,n){var r=this.templateCache,s=e+":"+(n||v.tags).join(":"),i=void 0!==r,l=i?r.get(s):void 0;return null==l&&(l=function(e,n){if(!e)return[];var r,s,i,l=!1,f=[],m=[],b=[],w=!1,_=!1,y="",x=0;function P(){if(w&&!_)for(;b.length;)delete m[b.pop()];else b=[];w=!1,_=!1}function k(e){if("string"==typeof e&&(e=e.split(p,2)),!t(e)||2!==e.length)throw new Error("Invalid tags: "+e);r=new RegExp(a(e[0])+"\\s*"),s=new RegExp("\\s*"+a(e[1])),i=new RegExp("\\s*"+a("}"+e[1]))}k(n||v.tags);for(var C,j,U,E,M,T,S=new h(e);!S.eos();){if(C=S.pos,U=S.scanUntil(r))for(var L=0,D=U.length;L<D;++L)o(E=U.charAt(L))?(b.push(m.length),y+=E):(_=!0,l=!0,y+=" "),m.push(["text",E,C,C+1]),C+=1,"\n"===E&&(P(),y="",x=0,l=!1);if(!S.scan(r))break;if(w=!0,j=S.scan(g)||"name",S.scan(c),"="===j?(U=S.scanUntil(d),S.scan(d),S.scanUntil(s)):"{"===j?(U=S.scanUntil(i),S.scan(u),S.scanUntil(s),j="&"):U=S.scanUntil(s),!S.scan(s))throw new Error("Unclosed tag at "+S.pos);if(M=">"==j?[j,U,C,S.pos,y,x,l]:[j,U,C,S.pos],x++,m.push(M),"#"===j||"^"===j)f.push(M);else if("/"===j){if(!(T=f.pop()))throw new Error('Unopened section "'+U+'" at '+C);if(T[1]!==U)throw new Error('Unclosed section "'+T[1]+'" at '+C)}else"name"===j||"{"===j||"&"===j?_=!0:"="===j&&k(U)}if(P(),T=f.pop())throw new Error('Unclosed section "'+T[1]+'" at '+S.pos);return function(e){for(var t,n=[],a=n,r=[],s=0,i=e.length;s<i;++s)switch((t=e[s])[0]){case"#":case"^":a.push(t),r.push(t),a=t[4]=[];break;case"/":r.pop()[5]=t[2],a=r.length>0?r[r.length-1][4]:n;break;default:a.push(t)}return n}(function(e){for(var t,n,a=[],r=0,s=e.length;r<s;++r)(t=e[r])&&("text"===t[0]&&n&&"text"===n[0]?(n[1]+=t[1],n[3]=t[3]):(a.push(t),n=t));return a}(m))}(e,n),i&&r.set(s,l)),l},m.prototype.render=function(e,t,n,a){var r=this.parse(e,a),s=t instanceof f?t:new f(t,void 0);return this.renderTokens(r,s,n,e,a)},m.prototype.renderTokens=function(e,t,n,a,r){for(var s,i,o,l="",c=0,p=e.length;c<p;++c)o=void 0,"#"===(i=(s=e[c])[0])?o=this.renderSection(s,t,n,a):"^"===i?o=this.renderInverted(s,t,n,a):">"===i?o=this.renderPartial(s,t,n,r):"&"===i?o=this.unescapedValue(s,t):"name"===i?o=this.escapedValue(s,t):"text"===i&&(o=this.rawValue(s)),void 0!==o&&(l+=o);return l},m.prototype.renderSection=function(e,a,r,s){var i=this,o="",l=a.lookup(e[1]);if(l){if(t(l))for(var c=0,p=l.length;c<p;++c)o+=this.renderTokens(e[4],a.push(l[c]),r,s);else if("object"==typeof l||"string"==typeof l||"number"==typeof l)o+=this.renderTokens(e[4],a.push(l),r,s);else if(n(l)){if("string"!=typeof s)throw new Error("Cannot use higher-order sections without the original template");null!=(l=l.call(a.view,s.slice(e[3],e[5]),(function(e){return i.render(e,a,r)})))&&(o+=l)}else o+=this.renderTokens(e[4],a,r,s);return o}},m.prototype.renderInverted=function(e,n,a,r){var s=n.lookup(e[1]);if(!s||t(s)&&0===s.length)return this.renderTokens(e[4],n,a,r)},m.prototype.indentPartial=function(e,t,n){for(var a=t.replace(/[^ \t]/g,""),r=e.split("\n"),s=0;s<r.length;s++)r[s].length&&(s>0||!n)&&(r[s]=a+r[s]);return r.join("\n")},m.prototype.renderPartial=function(e,t,a,r){if(a){var s=n(a)?a(e[1]):a[e[1]];if(null!=s){var i=e[6],o=e[5],l=e[4],c=s;return 0==o&&l&&(c=this.indentPartial(s,l,i)),this.renderTokens(this.parse(c,r),t,a,c,r)}}},m.prototype.unescapedValue=function(e,t){var n=t.lookup(e[1]);if(null!=n)return n},m.prototype.escapedValue=function(e,t){var n=t.lookup(e[1]);if(null!=n)return v.escape(n)},m.prototype.rawValue=function(e){return e[1]};var v={name:"mustache.js",version:"4.0.1",tags:["{{","}}"],clearCache:void 0,escape:void 0,parse:void 0,render:void 0,Scanner:void 0,Context:void 0,Writer:void 0,set templateCache(e){b.templateCache=e},get templateCache(){return b.templateCache}},b=new m;return v.clearCache=function(){return b.clearCache()},v.parse=function(e,t){return b.parse(e,t)},v.render=function(e,n,a,r){if("string"!=typeof e)throw new TypeError('Invalid template! Template should be a "string" but "'+((t(s=e)?"array":typeof s)+'" was given as the first argument for mustache#render(template, view, partials)'));var s;return b.render(e,n,a,r)},v.escape=function(e){return String(e).replace(/[&<>"'`=\/]/g,(function(e){return l[e]}))},v.Scanner=h,v.Context=f,v.Writer=m,v}));
